## slowmovideo-dmo 0.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

project(slowmoVideo)
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR "In-source builds are not allowed.")
endif()

set(CMAKE_CXX_STANDARD 14)

# Partly from https://doc.qt.io/qt-5/cmake-get-started.html#build-a-gui-executable
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)
if(CMAKE_VERSION VERSION_LESS "3.7.0")
    set(CMAKE_INCLUDE_CURRENT_DIR ON)
endif()


set(CMAKE_MODULE_PATH
  ${slowmoVideo_SOURCE_DIR}/cmake
)

# Make a version file containing the current version from git.
#
include(GetGitRevisionDescription)
git_describe(VERSION --dirty=-dev)
if (VERSION)
				#parse the version information into pieces.
			  # v0.4.0-123-gdddf621
				string(REGEX REPLACE "^v([0-9]+)\\..*" "\\1" PROJECT_VERSION_MAJOR "${VERSION}")
				string(REGEX REPLACE "^v[0-9]+\\.([0-9]+).*" "\\1" PROJECT_VERSION_MINOR "${VERSION}")
				string(REGEX REPLACE "^v[0-9]+\\.[0-9]+\\.([0-9]+)-.*" "\\1" PROJECT_VERSION_PATCH "${VERSION}")
				string(REGEX REPLACE "^v[0-9]+\\.[0-9]+-([0-9]+)-.*" "\\1" PROJECT_VERSION_PATCH "${VERSION}")
				string(REGEX REPLACE "^v[0-9]+\\.[0-9]+\\.[0-9]+-(.*)" "\\1" PROJECT_VERSION_SHA1 "${VERSION}")
else()
				set(PROJECT_VERSION_MAJOR "0")
				set(PROJECT_VERSION_MINOR "5")
				set(PROJECT_VERSION_PATCH "0")
endif()

if(NOT PROJECT_VERSION_PATCH)
				# git describe bug ?
				set(PROJECT_VERSION_PATCH "0")
endif()

set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
configure_file(src/version.h.in version.h)

### Compiler options ###

if (APPLE)
# To compile with clang:
#set(CMAKE_CXX_COMPILER "clang++")
#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall --verbose")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall ")
#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -O2 -mtune=corei7")

# Set additional project information
set(COMPANY "granjow")
set(COPYRIGHT "Copyright (c) 2011 Simon A. Eugster (Granjow). All rights reserved.")
set(IDENTIFIER "net.granjow.slomoui")

else()
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -g")
endif()

if(CMAKE_TOOLCHAIN_FILE)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DMXE")
  set(CMAKE_C_FLAGS "${CMAKE_CXX_FLAGS} -DMXE")
endif(CMAKE_TOOLCHAIN_FILE)


### CMake Configuration ###
option (ENABLE_TESTS "Build the unit tests" FALSE)
set(ADDITIONAL_LIBS "")
if(MSYS)
  message(STATUS "MSYS system detected.")
  include("${PROJECT_SOURCE_DIR}/cmake/MingwCrossEnv.cmake")
endif(MSYS)


### Find packages ###


# Check if environment variable QTDIR is set.
# needed for Qt5
# Extra security for windows environment as well.
if (DEFINED ENV{QTDIR})
    set(CMAKE_PREFIX_PATH $ENV{QTDIR} ${CMAKE_PREFIX_PATH})
endif ()

if (APPLE)
				set(DEST "slowmoUI.app/Contents/Tools/bin")
else()
				set(DEST "bin")
endif()

include(cmake/macros.cmake)

find_package(Qt5Core QUIET)
if (Qt5Core_FOUND)
	message(STATUS "Using Qt5")
	set(USE_QT TRUE)
	# go on with other packages
	find_package(Qt5 COMPONENTS Core Widgets Gui Xml Script REQUIRED)
	if (Qt5_POSITION_INDEPENDENT_CODE)
		set(CMAKE_POSITION_INDEPENDENT_CODE ON)
	endif (Qt5_POSITION_INDEPENDENT_CODE)
	#		 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}
	#		    ${Qt5Core_EXECUTABLE_COMPILE_FLAGS}")

	include_directories(${Qt5Core_INCLUDES})
	include_directories(${Qt5Widgets_INCLUDES})
	include_directories(${Qt5Gui_INCLUDES})
	include_directories(${Qt5Xml_INCLUDES})
	include_directories(${Qt5Script_INCLUDES})

	# set up a mapping so that the Release configuration for the Qt imported target is
	# used in the COVERAGE CMake configuration.
	#set_target_properties(Qt5::Core PROPERTIES MAP_IMPORTED_CONFIG_COVERAGE "DEBUG")

endif (Qt5Core_FOUND)


message("Qt libraries found at : ${Qt5Gui_LIBRARIES} /  ${QT_LIBRARIES}" )

set (USE_QTKIT OFF CACHE BOOL "Build with the QTKit encoder")
set (USE_FFMPEG ON CACHE BOOL "Build with the FFMPEG encoder")
set (USE_DBUS OFF CACHE BOOL "Build with the DBUS notification support")

if(NOT MSYS)
	find_package(FFMPEG)
else(NOT MSYS)
    # Handled by MingwCrossEnv.cmake to avoid errors like:
    # libavformat.a(avisynth.o):avisynth.c:(.text+0x6b): undefined reference to `AVIStreamRelease@4'
endif(NOT MSYS)
# not here anymore
#include_directories(${FFMPEG_INCLUDE_DIR})
#include_directories("/usr/include/ffmpeg/")
#link_directories(${FFMPEG_LIBRARY_DIR})

if (APPLE AND USE_QTKIT)
	find_package(QTKIT)
	message(STATUS "QTKIT find at ${QTKIT_LIBRARY} ")
	set(ADDITIONAL_LIBS "-framework Cocoa -framework QTKit -framework QuartzCore -framework AppKit -framework OpenCL")
endif()
	
# Find OpenCV, you may need to set OpenCV_DIR variable
# to the absolute path to the directory containing OpenCVConfig.cmake file
# via the command line or GUI
find_package(OpenCV REQUIRED)
# If the package has been found, several variables will
# be set, you can find the full list with descriptions
# in the OpenCVConfig.cmake file. 
# Print some message showing some of them
message(STATUS "OpenCV library status:")
message(STATUS " version: ${OpenCV_VERSION}")
message(STATUS " libraries: ${OpenCV_LIBS}")
message(STATUS " include path: ${OpenCV_INCLUDE_DIRS}")

if (${OpenCV_VERSION_MAJOR} EQUAL 3)
				set(HAS_OCV_VERSION_3 ON)
else()
				set(HAS_OCV_VERSION_3 OFF)
endif()

include_directories(${OPENCV_INCLUDE_DIRS})

# for config.h
include_directories(${CMAKE_CURRENT_BINARY_DIR})



### Set up libraries ###
if(MSYS)
    set(EXTERNAL_LIBS ${FFMPEG_LIBRARIES} ${QT_LIBRARIES} ${OpenCV_LIBS_OPT} ${OpenCV_EXTRA_LIBS_OPT} ${ADDITIONAL_LIBS})
else(MSYS)
    set(EXTERNAL_LIBS ${QT_LIBRARIES} ${OpenCV_LIBS} ${ADDITIONAL_LIBS} ${FFMPEG_LIBRARIES})
endif(MSYS)


### Information output
set(BUILD_SLOWMO "NO")
#if(QT_LIBRARIES AND FFMPEG_FOUND)
if(USE_QT AND FFMPEG_FOUND)
set(BUILD_SLOWMO "YES")
#endif(QT_LIBRARIES AND FFMPEG_FOUND)
endif()
if(NOT FFMPEG_SWSCALE_FOUND)
  if(CMAKE_TOOLCHAIN_FILE)

  else(CMAKE_TOOLCHAIN_FILE)
  set(BUILD_SLOWMO "NO")
  endif(CMAKE_TOOLCHAIN_FILE)
endif(NOT FFMPEG_SWSCALE_FOUND)


## Include projects to build ##

include_directories(src/tr)
add_subdirectory(src/lib)
add_subdirectory(src/lib/libsvflow)
add_subdirectory(src/libgui)
add_subdirectory(src/project)
add_subdirectory(src/slowmoCLI)
add_subdirectory(src/slowmoUI)
add_subdirectory(src/slowmoFlowEdit)
add_subdirectory(src/slowmoInfo)
add_subdirectory(src/slowmoRenderer)
add_subdirectory(src/visualizeFlow)
if(ENABLE_TESTS)
  SET(QT_USE_QTTEST TRUE)
  ## add_subdirectory(slowmoVideo/test)
  add_subdirectory(slowmoVideo/unittests)
endif(ENABLE_TESTS)

##### SV END #####






message("==================slowmoVideo========================")
message("* (info) slowmoVideo installation goes to ${CMAKE_INSTALL_PREFIX}.")
message("         (Can be adjusted with -DCMAKE_INSTALL_PREFIX=your_path. Default is ${SV_INST_DIR}.)")
#if(NOT QT_LIBRARIES)
if (NOT USE_QT)
    message("Qt5 libraries could not be found.")
#endif(NOT QT_LIBRARIES)
endif(NOT USE_QT)
if(NOT FFMPEG_FOUND)
    message("x ffmpeg libraries could not be found.")
else(NOT FFMPEG_FOUND)
    message("* (ok) ffmpeg found at ${FFMPEG_LIBRARY_DIR}")
endif(NOT FFMPEG_FOUND)
if(NOT FFMPEG_SWSCALE_FOUND)
    message("x libswscale could not be found.")
endif(NOT FFMPEG_SWSCALE_FOUND)
if(NOT OpenCV_VERSION)
    message("x OpenCV could not be found.")
else(NOT OpenCV_VERSION)
    message("* (ok) OpenCV ${OpenCV_VERSION} found at ${OpenCV_INCLUDE_DIRS}.")
endif(NOT OpenCV_VERSION)
message("* slowmoVideo will be built:                ---${BUILD_SLOWMO}---")
message("=======================END===========================")
message("")


if(NOT BUILD_SLOWMO)
    error(WARNING "Cannot build slowmoVideo, please install the missing packages first.")
endif(NOT BUILD_SLOWMO)

configure_file(src/config.h.in config.h)

=== src/lib/CMakeLists.txt ===
# Static libraries
# http://www.itk.org/pipermail/insight-users/2007-November/024141.html
# http://www.linux-magazin.de/Heft-Abo/Ausgaben/2007/02/Mal-ausspannen

set(LIB_SRC_BASE
  defs_sV.cpp
  defs_sV.hpp
  vector_sV.cpp
  shutter_sV.cpp
  intMatrix_sV.cpp
  interpolate_sV.cpp
  bezierTools_sV.cpp
  sourceField_sV.cpp
  libsvflow/src/flowField_sV.cpp
)

set(LIB_SRC_VIDEO
  defs_sV.h
  videoInfo_sV.cpp
  avconvInfo_sV.cpp
)

set(LIB_SRC_ARGS
  trivialArgsReader_sV.cpp
)

set(LIB_SRC_FLOWTOOLS
  flowTools_sV.cpp
  kernel_sV.cpp
)

set(LIB_SRC_FLOWVIS
  flowVisualization_sV.cpp
)


set(LIB_SRC_ENCODE
  macros_sV.h
  video_enc.h
  ffmpeg_writer.h
  ffmpeg_writer.cpp
  video_enc.cpp
)

if (OLD_FFMPEG)
set(LIB_SRC_ENCODE
	${LIB_SRC_ENCODE}
	  ffmpegEncode_sV.c
)
endif()

if (APPLE AND USE_QTKIT)
set(LIB_SRC_ENCODE
	${LIB_SRC_ENCODE}
	qtkit.h
	qtkit.mm
)
endif()

message(STATUS "FFMPEG libraries are at ${FFMPEG_LIBRARIES}")

include_directories(${FFMPEG_INCLUDE_PATHS})
include_directories(libsvflow)

add_library(sV  STATIC ${LIB_SRC_BASE})
target_link_libraries(sV  ${QT_LIBRARIES} sVflow)
qt5_use_modules(sV Core)
qt5_use_modules(sV Gui)

add_library(sVinfo  STATIC ${LIB_SRC_VIDEO})
qt5_use_modules(sVinfo Core)
qt5_use_modules(sVinfo Gui)
target_link_libraries(sVinfo  ${FFMPEG_LIBRARIES})

add_library(sVencode  STATIC ${LIB_SRC_ENCODE})
target_link_libraries(sVencode  ${FFMPEG_LIBRARIES} sVflow)
qt5_use_modules(sVencode Core)
qt5_use_modules(sVencode Gui)

add_library(sVflowtools  STATIC ${LIB_SRC_FLOWTOOLS})
target_link_libraries(sVflowtools sVflow)

add_library(sVvis  STATIC ${LIB_SRC_FLOWVIS})
qt5_use_modules(sVvis Core)
qt5_use_modules(sVvis Gui)
target_link_libraries(sVvis  sVflow ${QT_LIBRARIES})

=== src/libgui/CMakeLists.txt ===
set(SRCS
    imageDisplay.cpp
    combinedShortcuts.cpp
)


include_directories(
        ${CMAKE_BINARY_DIR}/libgui
        ../lib/libsvflow
)

add_library(sVgui STATIC ${SRCS})
qt5_use_modules(sVgui Core)
qt5_use_modules(sVgui Gui)
qt5_use_modules(sVgui Widgets)
target_link_libraries(sVgui  ${EXTERNAL_LIBS})

# If the library is used in a different project, cmake requires:
#include_directories(${slowmoVideo_SOURCE_DIR}/libgui)

=== src/project/CMakeLists.txt ===
set(SRCS_PROJ
  project_sV.cpp
  projectPreferences_sV.cpp
  renderPreferences_sV.cpp
  tag_sV.cpp
  node_sV.cpp
  nodeList_sV.cpp
  segment_sV.cpp
  segmentList_sV.cpp
  nodeHandle_sV.cpp
  renderTask_sV.cpp
  xmlProjectRW_sV.cpp
  abstractFrameSource_sV.cpp
  imagesFrameSource_sV.cpp
  videoFrameSource_sV.cpp
  emptyFrameSource_sV.cpp
  abstractRenderTarget_sV.cpp
  imagesRenderTarget_sV.cpp
  videoRenderTarget_sV.cpp
  abstractFlowSource_sV.cpp
  flowSourceOpenCV_sV.cpp
  flowSourceV3D_sV.cpp
  interpolator_sV.cpp
  shutterFunction_sV.cpp
  shutterFunctionList_sV.cpp
  motionBlur_sV.cpp
  canvasObject_sV.h
  exportVideoRenderTarget.cpp
  work_flow.cpp
)

if (OLD_FFMPEG)
set(SRCS_PROJ
	${SRCS_PROJ}
  new_videoRenderTarget.cpp
)
endif()

include_directories(${FFMPEG_INCLUDE_PATHS})
add_library(sVproj STATIC ${SRCS_PROJ})
qt5_use_modules(sVproj Core)
qt5_use_modules(sVproj Gui)
qt5_use_modules(sVproj Xml)
qt5_use_modules(sVproj Script)
target_link_libraries(sVproj sV sVinfo sVflow sVencode ${EXTERNAL_LIBS})

=== src/slowmoFlowEdit/CMakeLists.txt ===

include_directories(${slowmoVideo_SOURCE_DIR})

set(SRCS
    main.cpp
    mainwindow.cpp
    flowEditCanvas.cpp
    shortcutListDialog.cpp
)

if(APPLE)
        set(BUNDLE "slowmoFlowEdit")
        set(ICONS_DIR "${${PROJECT_NAME}_SOURCE_DIR}/slowmoVideo/slowmoUI/res")
        message( "OS X build" )
        set(MACOSX_BUNDLE_INFO_STRING "${BUNDLE} ${PROJECT_VERSION}")
        set(MACOSX_BUNDLE_BUNDLE_VERSION "${BUNDLE} ${PROJECT_VERSION}")
        set(MACOSX_BUNDLE_LONG_VERSION_STRING "${BUNDLE} ${PROJECT_VERSION}")
        set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${PROJECT_VERSION}")
        set(MACOSX_BUNDLE_COPYRIGHT "${PROJECT_COPYRIGHT_YEAR} ${PROJECT_VENDOR}")
        set(MACOSX_BUNDLE_ICON_FILE "slowmoUI.icns")
        set(MACOSX_BUNDLE_GUI_IDENTIFIER "${PROJECT_DOMAIN_SECOND}.${PROJECT_DOMAIN_FIRST}")
        set(MACOSX_BUNDLE_BUNDLE_NAME "${BUNDLE}")

        set(MACOSX_BUNDLE_RESOURCES "${CMAKE_CURRENT_BINARY_DIR}/${BUNDLE}.app/Contents/Resources")
        set(MACOSX_BUNDLE_ICON "${ICONS_DIR}/${MACOSX_BUNDLE_ICON_FILE}")
        SET_SOURCE_FILES_PROPERTIES(
           ${MACOSX_BUNDLE_ICON}
            PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
        message(STATUS "Bundle will be : ${MACOSX_BUNDLE} =>  ${PROJECT_NAME} ")

        set( SRCS ${SRCS} ${MACOSX_BUNDLE_ICON} )

endif()

include_directories(..)
include_directories(${CMAKE_BINARY_DIR}/slowmoVideo/slowmoFlowEdit)
include_directories(${CMAKE_BINARY_DIR}/slowmoVideo/libgui)

add_executable(slowmoFlowEdit WIN32 MACOSX_BUNDLE ${SRCS})
qt5_use_modules(slowmoFlowEdit Widgets Gui  Core )
target_link_libraries(slowmoFlowEdit sVgui sVflow sVvis sVflowtools)

#install(TARGETS slowmoFlowEdit
#        BUNDLE DESTINATION . COMPONENT Runtime
#        RUNTIME DESTINATION ${DEST} COMPONENT Runtime)

        #install(TARGETS slowmoUI DESTINATION ".")
        #install(TARGETS slowmoFlowEdit DESTINATION ${DEST})

include(DeployQt5) # 2.8.7 or later


if (APPLE)
       install(TARGETS slowmoFlowEdit DESTINATION ".")
       install_qt5_executable(slowmoFlowEdit.app "" ""  )
elseif(WIN32)
       install(TARGETS slowmoFlowEdit DESTINATION ".")
       install_qt5_executable(slowmoFlowEdit.exe "" ""  )
else()
       install(TARGETS slowmoFlowEdit DESTINATION ${DEST})
#       install_qt5_executable(slowmoFlowEdit "" ""  )
endif()

=== src/slowmoUI/CMakeLists.txt ===

# Building Qt+UI apps:
# http://www.qtcentre.org/wiki/index.php?title=Compiling_Qt4_apps_with_CMake
# http://www.cmake.org/pipermail/cmake/2008-September/023908.html



include_directories(${slowmoVideo_SOURCE_DIR})

set(SRCS
  main.cpp
  mainwindow.cpp
  canvas.cpp
  canvasTools.cpp
  flowEditCanvas.cpp
  frameMonitor.cpp
  renderPreview.cpp
  dialogues/newProjectDialog.cpp
  dialogues/preferencesDialog.cpp
  dialogues/projectPreferencesDialog.cpp
  dialogues/progressDialog.cpp
  dialogues/renderingDialog.cpp
  dialogues/shutterFunctionDialog.cpp
  dialogues/shutterFunctionFrame.cpp
  dialogues/flowExaminer.cpp
  dialogues/tagAddDialog.cpp
  dialogues/aboutDialog.cpp
  notificator.cpp
  logbrowserdialog.cpp
)

# notification
if (APPLE)
find_library(CORE_FOUNDATION NAMES CoreFoundation)
find_library(FOUNDATION NAMES Foundation)
find_library(APPLICATION_SERVICES NAMES ApplicationServices)
find_library(CORE_SERVICES NAMES CoreServices)
find_library(COCOA NAMES Cocoa)

SET(OSX_EXTRA_LIBS ${FOUNDATION} ${CORE_FOUNDATION} ${APPLICATION_SERVICES})
message(STATUS "OSX Additional libraries: ${OSX_EXTRA_LIBS}")

set(SRCS
        ${SRCS}
        macnotificationhandler.mm
)
endif()

set(SRCS_UI
  mainwindow.ui
  canvas.ui
  frameMonitor.ui
  renderPreview.ui
  flowEditCanvas.ui
  dialogues/newProjectDialog.ui
  dialogues/preferencesDialog.ui
  dialogues/projectPreferencesDialog.ui
  dialogues/progressDialog.ui
  dialogues/renderingDialog.ui
  dialogues/shutterFunctionDialog.ui
  dialogues/flowExaminer.ui
  dialogues/tagAddDialog.ui
  dialogues/aboutDialog.ui
)

if(APPLE)
	set(BUNDLE "slowmoUI")
	set(ICONS_DIR "${${PROJECT_NAME}_SOURCE_DIR}/slowmoVideo/slowmoUI/res")
        message( "OS X build" )
        set(MACOSX_BUNDLE_INFO_STRING "${BUNDLE} ${PROJECT_VERSION}")
        set(MACOSX_BUNDLE_BUNDLE_VERSION "${BUNDLE} ${PROJECT_VERSION}")
        set(MACOSX_BUNDLE_LONG_VERSION_STRING "${BUNDLE} ${PROJECT_VERSION}")
        set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${PROJECT_VERSION}")
        set(MACOSX_BUNDLE_COPYRIGHT ${COPYRIGHT} )
        set(MACOSX_BUNDLE_ICON_FILE "slowmoUI.icns")
        set(MACOSX_BUNDLE_GUI_IDENTIFIER ${IDENTIFIER} )
        set(MACOSX_BUNDLE_BUNDLE_NAME "${BUNDLE}")

        set(MACOSX_BUNDLE_RESOURCES "${CMAKE_CURRENT_BINARY_DIR}/${BUNDLE}.app/Contents/Resources")
        set(MACOSX_BUNDLE_ICON "${ICONS_DIR}/${MACOSX_BUNDLE_ICON_FILE}")
	SET_SOURCE_FILES_PROPERTIES(
	   ${MACOSX_BUNDLE_ICON} 
	    PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
        message(STATUS "slowmoUI Bundle will be : ${MACOSX_BUNDLE} ")

	set( SRCS ${SRCS} ${MACOSX_BUNDLE_ICON} )

  set(INFO_PLIST_FILENAME ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
  configure_file(${CMAKE_SOURCE_DIR}/slowmoVideo/slowmoUI/res/Info.plist.in ${INFO_PLIST_FILENAME})
  set_target_properties(${PROGNAME} PROPERTIES
                        MACOSX_BUNDLE_INFO_PLIST ${INFO_PLIST_FILENAME} )
  #ADD_CUSTOM_COMMAND(TARGET slowmoUI
  #  POST_BUILD
  #  COMMAND cp Info.plist slowmoUI.app/Contents/Info.plist
  #  COMMENT "Updating Info.plist"
  #  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR} )

endif()

# Without these includes the promoted widgets fail to compile
# since the headers are not found. (For whatever reason.)
include_directories(dialogues)
include_directories(.)
include_directories(..)

# Embed images in the binary
set(SRC_RES resources.qrc)
qt5_add_resources(RES_OUT ${SRC_RES})

# Generate header files from the .ui files

# Include the generated header files
include_directories(${CMAKE_BINARY_DIR}/slowmoVideo/slowmoUI)


link_directories(${FFMPEG_LIBRARY_DIR})
add_executable(slowmoUI WIN32 MACOSX_BUNDLE ${SRCS} ${RES_OUT})
qt5_use_modules(slowmoUI Script Widgets Concurrent Gui  Core )
target_link_libraries(slowmoUI sVproj sVvis sVgui sVflow sVflowtools ${OSX_EXTRA_LIBS})

#install(TARGETS ${slowmoUI}
#        BUNDLE DESTINATION . COMPONENT Runtime
#        RUNTIME DESTINATION ${BIN_INSTALL_DIR} COMPONENT Runtime)

if (UNIX AND NOT APPLE)
# create desktop file for KDE/Gnome
# desktop file section
	file( WRITE "${PROJECT_BINARY_DIR}/slowmoUI.desktop"
"#!/usr/bin/env xdg-open
[Desktop Entry]
Type=Application
Comment=Slow Motion Video
Exec=${CMAKE_INSTALL_PREFIX}/bin/slowmoUI
GenericName=slowmoVideo
Icon=${CMAKE_INSTALL_PREFIX}/share/icons/AppIcon
MimeType=
Name=slowmoUI
Terminal=false
Categories=Qt;AudioVideo;Video;\n")

	#install ( FILES icons/slowmoUI.png DESTINATION share/icons )
	install ( FILES res/AppIcon.png DESTINATION share/icons )
	install ( FILES ${PROJECT_BINARY_DIR}/slowmoUI.desktop DESTINATION share/applications
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)
endif()

include(DeployQt5)


#set( PLUGINS "qjpeg;qtiff" )
set( PLUGINS qjpeg )
if (APPLE)
       install(TARGETS slowmoUI DESTINATION ".")
       install_qt5_executable(slowmoUI.app "${PLUGINS}"  )
elseif(WIN32)
       install(TARGETS slowmoUI DESTINATION ".")
       install_qt5_executable(slowmoUI.exe "${PLUGINS}"  )
else()
       install(TARGETS slowmoUI DESTINATION ${DEST})
#       install_qt5_executable(slowmoUI "${PLUGINS}"  )
endif()

=== src/unittests/CMakeLists.txt ===

set(SRCS
    testFlowRW_sV.cpp
    testFlowField_sV.cpp
    testVector_sV.cpp
    testIntMatrix_sV.cpp
    testXmlProjectRW_sV.cpp
    testDefs_sV.cpp
    testShutterFunction_sV.cpp
    testProject_sV.cpp
    testNodeList_sV.cpp
    testAll.cpp
)

include_directories(${FFMPEG_INCLUDE_PATHS})
add_executable(UnitTests ${SRCS})
qt5_use_modules(UnitTests Concurrent  Core Test)
target_link_libraries(UnitTests sVproj ${EXTERNAL_LIBS})

add_test(UnitTests UnitTests)

=== src/visualizeFlow/CMakeLists.txt ===

include_directories(..)

set(SRCS
    visualizeFlow.cpp
)

add_executable(slowmoVisualizeFlow ${SRCS})
target_link_libraries(slowmoVisualizeFlow sVvis sVflowtools)

install(TARGETS slowmoVisualizeFlow DESTINATION ${DEST})

=== src/lib/libsvflow/CMakeLists.txt ===
# Follows this post: https://stackoverflow.com/a/45843676/271961

cmake_minimum_required(VERSION 3.0)

set(CMAKE_CXX_STANDARD 14)

if (CMAKE_VERSION VERSION_LESS 3.9)
    project(libsvflow VERSION 1.0.0)
else ()
    project(libsvflow VERSION 1.0.0 DESCRIPTION "Library for optical flow files")
endif ()

set(LIB_SRC_FLOW
        src/flowRW_sV.cpp
        src/flowField_sV.cpp
        )
set(HEADERS
        include/flowRW_sV.h
        include/flowField_sV.h
        )


add_library(sVflow STATIC ${LIB_SRC_FLOW})
set_target_properties(sVflow PROPERTIES VERSION ${PROJECT_VERSION})
target_include_directories(sVflow PUBLIC src)
target_include_directories(sVflow PUBLIC include)

=== debian/changelog ===
slowmovideo-dmo (1:0.6-dmo2) unstable; urgency=medium

  * Build with opencv 4.5

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 22 Dec 2020 11:04:01 +0100

slowmovideo-dmo (1:0.6-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 13 Apr 2020 08:53:11 +0200

slowmovideo-dmo (1:0.5+20190211.git6ed913bbf0-dmo3) unstable; urgency=medium

  * Build with opencv 4.2

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 01 Feb 2020 08:43:18 +0100

slowmovideo-dmo (1:0.5+20190211.git6ed913bbf0-dmo2) unstable; urgency=medium

  * Build against qtbase-abi-5-12-5 and/or qtdeclarative-abi-5-12-5

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 23 Oct 2019 13:08:37 +0200

slowmovideo-dmo (1:0.5+20190211.git6ed913bbf0-dmo1) unstable; urgency=medium

  * Git snapshot.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 17 Oct 2019 09:12:01 +0200

slowmovideo-dmo (1:0.5+20170829.git32b1902d3f-dmo3) unstable; urgency=medium

  * Swith to debhelper-compat

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 04 Feb 2019 11:33:35 +0100

slowmovideo-dmo (0.5+20170829.git32b1902d3f-dmo2) unstable; urgency=medium

  * Rebuild against libglew2.1

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 18 Nov 2018 17:29:13 +0100

slowmovideo-dmo (0.5+20170829.git32b1902d3f-dmo1) unstable; urgency=medium

  * Git snapshot with support for opencv 3.2

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 16 Oct 2017 13:23:02 +0200

slowmovideo-dmo (0.5-dmo4) unstable; urgency=medium

  * Rebuild with PIE

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 05 Mar 2017 17:06:22 +0100

slowmovideo-dmo (0.5-dmo3) unstable; urgency=medium

  * Rebuild against libglew2.0

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 09 Sep 2016 07:35:36 +0200

slowmovideo-dmo (0.5-dmo2) unstable; urgency=medium

  * Fix kfreebsd FTBFS.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 08 Sep 2016 08:19:04 +0200

slowmovideo-dmo (0.5-dmo1) unstable; urgency=low

  * Initial release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 07 Sep 2016 09:38:16 +0200

=== debian/control ===
Source: slowmovideo-dmo
Section: video
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://github.com/slowmoVideo/slowmoVideo/wiki
Standards-Version: 4.3.0
Build-Depends: debhelper-compat (= 13), cmake, qtbase5-dev, libopencv-dev (>= 4.2~),
 libjpeg-dev, libpng-dev, libavcodec-dev, libavformat-dev, libavutil-dev,
 libswscale-dev, qtscript5-dev, ocl-icd-opencl-dev, libglew-dev (>= 2.0.0),
 libglu1-mesa-dev, freeglut3-dev, quilt, ninja-build

Package: slowmovideo
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: creates slow-motion videos from your footage.
 slowmoVideo is an OpenSource program that creates slow-motion videos from
 your footage.
 .
 But it does not simply make your videos play at 0.01× speed.  You can
 smoothly slow down and speed up your footage, optionally with motion blur.
 .
 How does slow motion work?  slowmoVideo tries to find out where pixels move
 in the video (this information is called Optical Flow), and then uses this
 information to calculate the additional frames between the ones recorded by
 your camera.
 .
 Features
   * Videos in any format supported by ffmpeg can be loaded.  Image
     sequences can also be loaded, so, if you did a timelapse with too few
     frames, slowmoVideo may help as well.
   * slowmoVideo does not work with a constant slowdown factor but with
     curves that allow arbitrary time accelereation/deceleration/reversal.
   * Motion blur can be added, as much as you want.
 .
 See nice example videos here : http://slowmovideo.granjow.net/videos.html

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -Scmake+ninja --with quilt

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_BUILD_TYPE:STRING=Release

#	exit 1

override_dh_auto_test:

=== debian/watch ===
version=4

https://github.com/slowmoVideo/slowmoVideo/releases \
(?:.*?/)?v?(\d[\d.]*)@ARCHIVE_EXT@

## slowmovideo-dmo 0.6.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,26 +24,28 @@
 #
 include(GetGitRevisionDescription)
 git_describe(VERSION --dirty=-dev)
-if (VERSION)
-				#parse the version information into pieces.
-			  # v0.4.0-123-gdddf621
-				string(REGEX REPLACE "^v([0-9]+)\\..*" "\\1" PROJECT_VERSION_MAJOR "${VERSION}")
-				string(REGEX REPLACE "^v[0-9]+\\.([0-9]+).*" "\\1" PROJECT_VERSION_MINOR "${VERSION}")
-				string(REGEX REPLACE "^v[0-9]+\\.[0-9]+\\.([0-9]+)-.*" "\\1" PROJECT_VERSION_PATCH "${VERSION}")
-				string(REGEX REPLACE "^v[0-9]+\\.[0-9]+-([0-9]+)-.*" "\\1" PROJECT_VERSION_PATCH "${VERSION}")
-				string(REGEX REPLACE "^v[0-9]+\\.[0-9]+\\.[0-9]+-(.*)" "\\1" PROJECT_VERSION_SHA1 "${VERSION}")
-else()
-				set(PROJECT_VERSION_MAJOR "0")
-				set(PROJECT_VERSION_MINOR "5")
-				set(PROJECT_VERSION_PATCH "0")
-endif()
-
-if(NOT PROJECT_VERSION_PATCH)
-				# git describe bug ?
-				set(PROJECT_VERSION_PATCH "0")
-endif()
+
+if (VERSION MATCHES "^v([0-9]+)\\.([0-9]+)(\\.([0-9]+))?(-[a-zA-Z0-9]+)?$")
+	string(REGEX REPLACE "^v([0-9]+)\\.([0-9]+)(\\.([0-9]+))?(-[a-zA-Z0-9]+)?$" "\\1" PROJECT_VERSION_MAJOR "${VERSION}")
+	string(REGEX REPLACE "^v([0-9]+)\\.([0-9]+)(\\.([0-9]+))?(-[a-zA-Z0-9]+)?$" "\\2" PROJECT_VERSION_MINOR "${VERSION}")
+	if (VERSION MATCHES "^v([0-9]+)\\.([0-9]+)(\\.([0-9]+))(-[a-zA-Z0-9]+)?$")
+		string(REGEX REPLACE "^v([0-9]+)\\.([0-9]+)(\\.([0-9]+))(-[a-zA-Z0-9]+)?$" "\\3" PROJECT_VERSION_PATCH "${VERSION}")
+	else ()
+		set(PROJECT_VERSION_PATCH "0")
+	endif ()
+	if (VERSION MATCHES "^v([0-9]+)\\.([0-9]+)(\\.([0-9]+))(-[a-zA-Z0-9]+)$")
+		string(REGEX REPLACE "^v([0-9]+)\\.([0-9]+)(\\.([0-9]+))(-[a-zA-Z0-9]+)$" "\\4" PROJECT_VERSION_SHA1 "${VERSION}")
+	else ()
+		set(PROJECT_VERSION_SHA1 "")
+	endif ()
+else ()
+	set(PROJECT_VERSION_MAJOR "0")
+	set(PROJECT_VERSION_MINOR "6")
+	set(PROJECT_VERSION_PATCH "0")
+endif ()
 
 set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
+message(STATUS "Building slowmoVideo ${PROJECT_VERSION}")
 configure_file(src/version.h.in version.h)
 
 ### Compiler options ###
@@ -158,10 +160,10 @@
 message(STATUS " libraries: ${OpenCV_LIBS}")
 message(STATUS " include path: ${OpenCV_INCLUDE_DIRS}")
 
-if (${OpenCV_VERSION_MAJOR} EQUAL 3)
-				set(HAS_OCV_VERSION_3 ON)
-else()
-				set(HAS_OCV_VERSION_3 OFF)
+set(OPENCV_OK, TRUE)
+if (${OpenCV_VERSION_MAJOR} LESS 3)
+	message(STATUS "OpenCV version is too old")
+	set(OPENCV_OK, FALSE)
 endif()
 
 include_directories(${OPENCV_INCLUDE_DIRS})
@@ -185,6 +187,9 @@
 if(USE_QT AND FFMPEG_FOUND)
 set(BUILD_SLOWMO "YES")
 #endif(QT_LIBRARIES AND FFMPEG_FOUND)
+endif()
+if(NOT ${OPENCV_OK})
+	set(BUILD_SLOWMO "NO")
 endif()
 if(NOT FFMPEG_SWSCALE_FOUND)
   if(CMAKE_TOOLCHAIN_FILE)
@@ -205,13 +210,12 @@
 add_subdirectory(src/slowmoCLI)
 add_subdirectory(src/slowmoUI)
 add_subdirectory(src/slowmoFlowEdit)
-add_subdirectory(src/slowmoInfo)
 add_subdirectory(src/slowmoRenderer)
 add_subdirectory(src/visualizeFlow)
 if(ENABLE_TESTS)
   SET(QT_USE_QTTEST TRUE)
-  ## add_subdirectory(slowmoVideo/test)
-  add_subdirectory(slowmoVideo/unittests)
+  ## add_subdirectory(srd/test)
+  add_subdirectory(src/unittests)
 endif(ENABLE_TESTS)
 
 ##### SV END #####
@@ -240,7 +244,11 @@
 if(NOT OpenCV_VERSION)
     message("x OpenCV could not be found.")
 else(NOT OpenCV_VERSION)
-    message("* (ok) OpenCV ${OpenCV_VERSION} found at ${OpenCV_INCLUDE_DIRS}.")
+	if(NOT OPENCV_OK)
+		message("x OpenCV version is too old: ${OpenCV_VERSION}")
+	else()
+		message("* (ok) OpenCV ${OpenCV_VERSION} found at ${OpenCV_INCLUDE_DIRS}.")
+	endif()
 endif(NOT OpenCV_VERSION)
 message("* slowmoVideo will be built:                ---${BUILD_SLOWMO}---")
 message("=======================END===========================")
@@ -248,7 +256,7 @@
 
 
 if(NOT BUILD_SLOWMO)
-    error(WARNING "Cannot build slowmoVideo, please install the missing packages first.")
+    message(FATAL_ERROR "Cannot build slowmoVideo, please install the missing packages first.")
 endif(NOT BUILD_SLOWMO)
 
 configure_file(src/config.h.in config.h)

=== src/slowmoRenderer/CMakeLists.txt ===

include_directories(..)

set(SRCS
    rendererMain.cpp
    slowmoRenderer_sV.cpp
)

add_executable(slowmoRenderer ${SRCS})
target_link_libraries(slowmoRenderer sVproj ${EXTERNAL_LIBS})
qt5_use_modules(slowmoRenderer Script Widgets Concurrent Gui  Core )
install(TARGETS slowmoRenderer DESTINATION ${DEST})

=== src/unittests/CMakeLists.txt ===
--- 
+++ 
@@ -15,6 +15,6 @@
 include_directories(${FFMPEG_INCLUDE_PATHS})
 add_executable(UnitTests ${SRCS})
 qt5_use_modules(UnitTests Concurrent  Core Test)
-target_link_libraries(UnitTests sVproj ${EXTERNAL_LIBS})
+target_link_libraries(UnitTests sVproj sVflowtools ${EXTERNAL_LIBS})
 
 add_test(UnitTests UnitTests)

=== debian/changelog ===
slowmovideo-dmo (1:0.6.2-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 20 Dec 2022 09:26:52 +0100

slowmovideo-dmo (1:0.6.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 25 Oct 2022 08:37:14 +0200

slowmovideo-dmo (1:0.6-dmo4) unstable; urgency=medium

  * Build with opencv 4.6.0

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 02 Jul 2022 07:30:43 +0200

slowmovideo-dmo (1:0.6-dmo3) unstable; urgency=medium

  * Build with opencv 4.5d

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 26 Nov 2021 09:59:58 +0100

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
 Build-Depends: debhelper-compat (= 13), cmake, qtbase5-dev, libopencv-dev (>= 4.2~),
  libjpeg-dev, libpng-dev, libavcodec-dev, libavformat-dev, libavutil-dev,
  libswscale-dev, qtscript5-dev, ocl-icd-opencl-dev, libglew-dev (>= 2.0.0),
- libglu1-mesa-dev, freeglut3-dev, quilt, ninja-build
+ libglu1-mesa-dev, freeglut3-dev, ninja-build
 
 Package: slowmovideo
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

# git clone  https://github.com/slowmoVideo/libsvflow.git src/lib/libsvflow
# cd src/lib/libsvflow
# git reset --hard 7c31a0b

%:
	dh $@ -Scmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_BUILD_TYPE=Release -Wno-dev

#	exit 1

override_dh_auto_test:

=== debian/watch ===
version=4

https://github.com/slowmoVideo/slowmoVideo/tags \
(?:.*?/)?v?(\d[\d.]*)@ARCHIVE_EXT@
